
Core - Task # 54091

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Story # 55078 (Closed): Optimize PHP code performance in TYPO3 methods

Status: Resolved Priority: Should have
Author: Markus Klein Category: Performance
Created: 2013-11-29 Assigned To:
Updated: 2015-01-18 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: medium
Sprint Focus:
Subject: Use === operator instead of strlen() to check for zero length strings
Description

Use the === operator instead of the strlen() function to check for strings of length zero.

This can give a performance improvement of factor 3.

Short note: Although some source claim that strlen() has O(1), for some reason the comparison against an empty string is still faster.

Nevertheless, besides the possible performance improvement, this change also improves readability.

Related issues:
related to Core - Bug # 67034: Content Slide: slide.collect issues since 7.1.0 Resolved 2015-05-19
related to Core - Bug # 65239: Missing (string) cast or isset() check in HTML... Resolved 2015-02-23
duplicated by Core - Task # 64199: Cleanup usage of strlen() Resolved 2015-01-09
precedes Core - Bug # 67040: Backend broken on PostgreSQL - missing (string) ... Resolved 2015-05-19

Associated revisions
Revision de27a20a - 2014-02-23 11:24 - Markus Klein

[CLEANUP] Replace strlen() with === for zero length check

It is faster to compare a string with === '' to find out if it's empty
than to run strlen() on it.

The replacement rules are applied as follows: *    if (strlen($str))
   => if ((string)$str !== '') *    if (!is_string($str) || strlen($str) === 0)
   => if (!is_string($str) || $str === '') * If it can be seen easily that $str is a string,
   the typecast is omitted.

Resolves: #54091
Releases: 6.2
Change-Id: I59c5cbccea4f98b8f282377e6aa67d970859a457
Reviewed-on: https://review.typo3.org/27091
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

Revision 4722b6cf - 2015-01-18 14:37 - Markus Klein
[CLEANUP] Replace strlen() with === for zero length check

It is faster to compare a string with === '' to find out if it's empty
than to run strlen() on it.

The replacement rules are applied as follows: *    if (strlen($str))
   => if ((string)$str !== '') *    if (!is_string($str) || strlen($str) === 0)
   => if (!is_string($str) || $str === '') * If it can be seen easily that $str is a string,
   the typecast is omitted.

Change-Id: I888d70e42f925bd57ad23b873b72d6a38acb39ef
Resolves: #54091
Releases: master
Reviewed-on: http://review.typo3.org/27794
Reviewed-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
Tested-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>
Tested-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

Revision a27dfad8 - 2015-05-20 00:20 - Morton Jonuschat

[BUGFIX] Add missing (string) cast in dbal/DatabaseConnection

This is a regression fix for #54091.
It has been forgotten to cast the lastQuery to a string before
checking if it's empty

Resolves: #67040
Related: #54091
Releases: master
Change-Id: I6991cad799e686066f8205749baee4aed20a9127
Reviewed-on: http://review.typo3.org/39625
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>

Revision bde48583 - 2015-06-15 12:52 - Benjamin Mack

[BUGFIX] CONTENT cObject slide does not loop

The CONTENT cObject is looping over the SQL query
when sliding the rootline and/or collecting but never
repeats due to missing braces.

This happened during a cleanup merge in commit
4722b6cf5c97ab415d3d35687ed77750b97e3258.

The patch re-adds the braces.
Resolves: #67034
Related: #54091
Releases: master
Change-Id: Ifc912ea8d5d2861d6888ddc5ac7bd755e3ff6bb4
Reviewed-on: http://review.typo3.org/40244
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>

History
#1 - 2013-12-01 16:30 - Stefan Neufeind

In general I like the idea.

Beware though that strlen() also returns 0 for FALSE, will cast non-strings to a string first (thus correctly gives string-length of integers etc.) and such.

#2 - 2013-12-11 23:02 - Jo Hasenau

Beware though that strlen() also returns 0 for FALSE, will cast non-strings to a string first (thus correctly gives string-length of integers etc.) and
such.

So 

(string)$foo === ''

should do the job and strlen() can stay for those cases that expect a length > 0

#3 - 2014-01-28 09:54 - Ernesto Baschny
- Target version set to 6.2.0
- Parent task changed from #52949 to #55078

#4 - 2014-01-28 11:06 - Markus Klein

I tested strlen() a bit.
1$c = FALSE;
2echo strlen($c); // 0
3echo (string)$c === '' ? 'empty' : 'not empty'; // empty
4echo $c === '' ? 'empty' : 'not empty'; // not empty

1$c = TRUE;
2echo strlen($c); // 1
3echo (string)$c === '' ? 'empty' : 'not empty'; // not empty
4echo $c === '' ? 'empty' : 'not empty'; // not empty

So it suffices to do the cast in cases were we are not sure about the type.
#5 - 2014-01-28 13:58 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#6 - 2014-01-28 14:17 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#7 - 2014-01-28 14:43 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#8 - 2014-01-28 17:21 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#9 - 2014-02-03 11:02 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#10 - 2014-02-06 22:08 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#11 - 2014-02-06 22:18 - Stefan Neufeind
- Subject changed from Use === operator instead of strlen() to check for zero length stirngs to Use === operator instead of strlen() to check for zero 
length strings

#12 - 2014-02-06 23:26 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#13 - 2014-02-18 18:18 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091
#14 - 2014-02-23 11:23 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27091

#15 - 2014-02-23 11:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:de27a20afbd8f413f60029afc5622c7b33212322.

#16 - 2014-02-23 13:20 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27794

#17 - 2014-03-04 07:21 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28017

#18 - 2014-03-04 08:08 - Michiel Roos

To make travis pass all the failing tests:

One issue is in \TYPO3\CMS\Core\Utility\GeneralUtility::xml2arrayProcess()
Around line: 2273:
            if ((string)$val['attributes']['index'] !== '') {
                $tagName = $val['attributes']['index'];
            }

Two more string casts are needed in: typo3/sysext/extbase/Classes/Scheduler/FieldProvider.php around line 244

Two more string casts are needed in typo3/sysext/extensionmanager/Classes/Utility/EmConfUtility.php around line 95:
-       if (strlen($emConf['PHP_version'])) {
+       if ((string)$emConf['PHP_version'] !== '') {
          $emConf['constraints']['depends']['php'] = $emConf['PHP_version'];
        }
-       if (strlen($emConf['TYPO3_version'])) {
+       if ((string)$emConf['TYPO3_version'] !== '') {
          $emConf['constraints']['depends']['typo3'] = $emConf['TYPO3_version'];
        }

#19 - 2014-03-04 10:10 - Gerrit Code Review
Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27794

#20 - 2014-03-05 09:20 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27794

#21 - 2014-05-30 11:31 - Markus Klein
- Target version deleted (6.2.0)

#22 - 2014-09-21 01:05 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#23 - 2015-01-11 18:51 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#24 - 2015-01-12 14:43 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#25 - 2015-01-17 11:27 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#26 - 2015-01-17 22:30 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#27 - 2015-01-18 12:03 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27794

#28 - 2015-01-18 15:00 - Markus Klein
- Status changed from Under Review to Resolved

2015-08-04 6/7

https://review.typo3.org/27794
https://review.typo3.org/27794
http://review.typo3.org/27794
http://review.typo3.org/27794
http://review.typo3.org/27794
http://review.typo3.org/27794
http://review.typo3.org/27794
http://review.typo3.org/27794


Applied in changeset commit:4722b6cf5c97ab415d3d35687ed77750b97e3258.
